/**
 *
 * \file Constantes.h
 * \author The VLE Development Team
 * See the AUTHORS or Authors.txt file
 * \version 2.0
 * \date 30 mai 2013
 * \brief regroupe toutes les constantes du programme.
 */

/*
 * Copyright (C) 2012-2013 ULCO http://www.univ-littoral.fr
 * Copyright (C) 2012-2013 INRA http://www.inra.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CONSTANTES_H_
#define CONSTANTES_H_

//#define DEBUG
#define SUJET 0
#define OBJET 1
#define VRAI 1
#define FAUX 0
#define LIG_KEY 1
#define COL_KEY 2
#define ALTITUDE 1
#define COULEUR 2
#define BASSIN 3
#define DRAIN 4
#define MNT 5
#define NODE 6
#define DERIVE 7
#define IMAGE 8
#define LAYER 9
#define RESEAU 10
#define EXUTOIRE 11
#define HAIE 12
#define EXTREMITE 13
#define ZHANG 14
#define NETW625 15
#define MASK 16
#define DRAIN_INI 17
#define MUR 18

#define RIEN -1
#define ASCII 99
#define NODATA -9999

#define ALT 0
#define SBV 1
#define DBV 2
#define LOD 3
#define LON 3
#define SML 4
#define LZD 4
#define CVX 4
#define PEN 5
#define BEV 6
#define PAV 7
#define MRT 8
#define CFL 9
#define DLT 9
#define EXP 10
#define DAR 10
#define APL 10
#define COV 11
#define PRM 11
#define DAS 11
#define LOV 11
#define DVV 11
#define CNT 12
#define IMA 12
#define RAY 15
#define MCX 15
#define	BASE 0
#define	ZOOM 1
#define	INFO 2
#define	AFFI 3
#define	SELE 4
#define	MAJ 5
#define	SUPP 6
#define	PROM1 7
#define	PROM2 8
#define	COUPE 9
#define RACCORD 10
#define MAJSBV 11
#define MAJMDD 12
#define MAJMUR 13

#define NORD 1
#define NORDOUEST 2
#define OUEST 3
#define SUDOUEST 4
#define SUD 5
#define SUDEST 6
#define EST 7
#define NORDEST 8
#define PLATEAU 9
#define EXUTOIRE_BORD 10
#define EXUTOIRE_MER 11
#define TROU 12

#define ARCINFO 0
#define DESCARTES 1
#define MAPINFO  2
#define ARCVIEW 3


#define LONGUEUR_LABEL_MAX 60
#define LONGUEUR_LIGNE_INDEX_VAR_MAX 129
#define NB_COUCHE_MAX 32
#define POUR_FREQUENCE 99
#define POUR_COUCHE 2

#define MAP 0
/* si 1: Affichage des elements de mise au point */

#define NB_DERIVES_MAX 50
#define RESEAU_HYDRO 1
#define CONTOUR_BASSIN 2
#define CONTOUR_IMAGE_BINAIRE 3
#define EXUTOIRES 4
#define AUTRES 5
#define NOMBRE_DE_CLASSE 1000
#define DEFAULT_COLORS 16
#define NB_FORMAT 5
#define NB_COULEURS_DYNAMIC 90
#define RAPPORT_SURFACE 10000
#define TROU_TOLERE 1
#define FACT 1000
#define EPSALT 0.00001
#define chemin_appli
#define LONGMAILLE 50.
#define ALTMER 0.1

#endif /* CONSTANTES_H_ */
